#!/bin/sh
# This script is to install LSIStorageAuthority RPM's
#

((setupstate))
{
SMTP_FILE="/opt/lsi/LSIStorageAuthority/bin/smtpServer"
KEY_FILE="/opt/lsi/LSIStorageAuthority/bin/key.store"
VALUE_FILE="/opt/lsi/LSIStorageAuthority/bin/value.store"

LSA_CONF="/opt/lsi/LSIStorageAuthority/conf/LSA.conf"
MONITOR_CONF="/opt/lsi/LSIStorageAuthority/conf/monitor/config-current.json"

lsa_temp="/opt/lsa_temp"

if [ -d "$lsa_temp" ];
then
	rm -rf "/opt/lsa_temp"
fi
	
# make new directory
mkdir "/opt/lsa_temp"

#

if [ -f "$SMTP_FILE" ];
then
	cp "$SMTP_FILE" "/opt/lsa_temp"
fi

#

if [ -f "$KEY_FILE" ];
then
	cp "$KEY_FILE" "/opt/lsa_temp"
fi

#

if [ -f "$VALUE_FILE" ];
then
	cp "$VALUE_FILE" "/opt/lsa_temp"
fi


#

if [ -f "$LSA_CONF" ];
then
	cp "$LSA_CONF" "/opt/lsa_temp"
fi


#

if [ -f "$MONITOR_CONF" ];
then
	cp "$MONITOR_CONF" "/opt/lsa_temp"
fi

#

./deleteOldVersion.sh
retval=$?
if [ $retval == 1 ]; then
  if [ -d "$lsa_temp" ];
  then
	rm -rf "/opt/lsa_temp"
  fi
  exit
fi
}
if [ -e /etc/os-release ]; then
   redHatOS=`cat /etc/os-release | grep  -w "NAME=" |  cut -b 7-13`
  if [ "$redHatOS" = "Red Hat" ]; then
      version=`cat /etc/os-release | grep  -w "VERSION=" |  cut -b 10-10`
   if [ "$version" -ge 9 ]; then
       echo
       echo "chkconfig package is not present by default. This package is required to auto start LWM service on system boot. "
       echo "Install chkconfig package before installing the LWM."
       echo
   fi
  fi
fi
if [ "$setuptype" = "" ]; then
	setuptype="g"
fi

IsPortAvailable()
{
    port=$1

    output=""

    if [[ -x "/bin/netstat" ]]
    then
        output=`netstat -na | grep LISTEN | grep :${port} | cut -d: -f2 | awk '{print $1}' | head -1`
    elif [[ -x "/usr/sbin/ss" ]]
    then
        output=`ss -l | grep LISTEN | grep ${port} | awk '{print $6}' | head -1`
    fi

    if [[ $output = "" ]]; then
        return 0
    fi

    if [ ${port} = ${output} ]; then
        return 1
    else
        return 0
    fi
}

IsStringContainingSpaces()
{
    string="$1"
    if [[ "$string" =~ \ + ]]; then
        return 1
    else
        return 0
    fi
}

IsPortInrange()
{
    port=$1

    validateStringLength $port 15
    if [ $? != 0 ]; then
        return 1
    fi
    if [ ${port} -lt 1 ] || [ ${port} -gt 65535 ]; then
        return 1
    else
        return 0
    fi
}

IsNumericValue()
{
    Value="$1"

    if [[ "$Value" =~ [^0-9]+ ]] ; then
        return 1
    else
        return 0
    fi
}

validateStringLength()
{
    string="$1"
    validLength=$2

    length=`echo "${string}" | awk '{ print length }'`
    if [ ${length} -gt ${validLength} ]; then
        return 1
    else
        return 0
    fi
}

getUserInput()
{
	if [ "$setupmode" = "SILENT" ]; then
           
		IsNumericValue $setupstate
		if [ $? != 0 ]; then
                    echo "Please enter valid alert notification value."
                    echo " "
                    echo "Exiting installation."
		    exit	
		fi
        	if [[ $setupstate = "" ]]; then
            	   setupstate="1"
        	fi

           setup_state_comp=$((setupstate+1))
	   if [ $setupstate -lt 1 ] || [ $setupstate -gt 4 ]; then
                 echo "The given alert notification value is out of valid range."
		exit
	   fi
        	setup_state=$((setupstate-1))
	else
	   setup_state=$((setupstate-1))

	fi
###########################################################################################
################ Read LSIStorageAuthority Port ############################################
###########################################################################################
    while (true)
    do
	if [ "$setupmode" = "SILENT" ]; then
		LSAappPort=$LSA_port
               IsNumericValue $LSA_port
                if [ $? != 0 ]; then
                    echo "Please enter valid Port Number."
                    echo " "
                    echo "Exiting installation."
                    exit
                fi
        	if [[ $LSAappPort = "" ]]; then
            	LSAappPort="9000"
        	fi
  	else
	        read -p 'Enter LSA port [9000] : ' LSAappPort
        	if [[ $LSAappPort = "" ]]; then
            	LSAappPort="9000"
        	fi
	fi

        IsNumericValue $LSAappPort
        if [ $? != 0 ]; then
            echo "Invalid Port number, try another one."
            continue
        fi

        IsPortInrange $LSAappPort
        if [ $? != 0 ]; then
            echo "The given Port Number is out of valid range[1-65535], try another one."
            continue
        fi

        IsPortAvailable $LSAappPort
        if [ $? = 0 ]; then
            break
        else
            #echo "The given Port is in use, try another one."
            while(true)
            do
                LSAappPort=$(( $LSAappPort + 1 ))

                IsPortAvailable $LSAappPort
                if [ $? = 0 ]; then
                    break
                fi

            done
            echo "The given port is in use, the next available port is $LSAappPort"
            echo ""
            read -p 'Would you like to continue with this available port [y/n]: ' config
            if [ "${config}" = "y" ] || [ "${config}" = "Y" ]; then
                break
            fi
        fi
    done
}

install_rpms ()
{
#3rd party library installation
utils_rpm=`rpm -qa | grep LSA_lib_utils- | wc -l`
if [ $utils_rpm = 0 ]; then
	echo "Installing  LSA_lib_utils-1.17-00"
        rpm -ivh LSA_lib_utils-1.17-00.x86_64.rpm 
else
        lib_newdate=1704782045
        lib_olddate=`rpm -q --queryformat "%{BUILDTIME}" LSA_lib_utils`
                if [ $lib_newdate -gt $lib_olddate ]; then
			echo "Installing  LSA_lib_utils-1.17-00"
                        rpm -ivh LSA_lib_utils-1.17-00.x86_64.rpm --force
		fi
                if [ $lib_newdate -eq $lib_olddate ]; then
                        echo "Latest LSA_lib_utils RPM is already installed"
                fi
fi

# Complete Installation
step1status_LSA=0
step1status_monitor=0
#if [ "$setuptype" = "c" ]; then
uninst="/opt/lsi/LSIStorageAuthority/.__uninst.sh"
        rpm --import pubKey.asc
	rpm -i --test LightWeightMonitor-008.009.009.000-00.x86_64.rpm
	status=$?
	if [ $status = 0 ]; then
  		echo "Installing  LightWeightMonitor-008.009.009.000-00"
  		rpm -ivh LightWeightMonitor-008.009.009.000-00.x86_64.rpm
	else
		step1status_LSA=1
  		echo "LightWeightMonitor RPM Installation Failed"
  		exit 1
	fi
	
	if [ $step1status_LSA = 0 ]; then
		echo "echo \"Uninstalling LightWeightMonitor-008.009.009.000-00\"" >> $uninst
		echo "rpm -e LightWeightMonitor-008.009.009.000-00 > /tmp/LSIStorageAuthority_uninstall.txt 2>&1" >> $uninst
		echo "status=\$?" >>$uninst
		echo "if [ \$status -ne 0 ]; then" >> $uninst
		echo "     echo" >> $uninst
		echo "     echo \"LWM uninstallation failed!\"" >> $uninst
		echo "     echo" >> $uninst
		echo "     exit 1" >> $uninst
		echo "fi" >> $uninst

        if [ -d "/opt/lsi/LSA/libs2" ]; then
                        echo "echo \"Uninstalling LSA_lib_utils2-9.00-00\"" >> $uninst
                        echo "rpm -e LSA_lib_utils2-9.00-00.x86_64 > /tmp/LSIStorageAuthority_uninstall.txt 2>&1" >> $uninst
                        echo "status=\$?" >>$uninst
                        echo "if [ \$status -ne 0 ]; then" >> $uninst
			echo "     echo" >> $uninst
			echo "     echo \"LSA uninstallation failed!\"" >> $uninst
			echo "     echo" >> $uninst
                        echo "     exit 1" >> $uninst
                        echo "fi" >> $uninst
                fi
 
                echo "echo \"Uninstalling LSA_lib_utils-1.17-00\"" >> $uninst
                echo "rpm -e LSA_lib_utils-1.17-00.x86_64 > /tmp/LSIStorageAuthority_uninstall.txt 2>&1" >> $uninst
                echo "status=\$?" >>$uninst
                echo "if [ \$status -ne 0 ]; then" >> $uninst
		echo "     echo" >> $uninst
		echo "     echo \"LSA uninstallation failed!\"" >> $uninst
		echo "     echo" >> $uninst
                echo "     exit 1" >> $uninst
                echo "fi" >> $uninst

                echo "rm -rf /opt/lsi/LSIStorageAuthority/bin/libstorelib* 2>|/dev/null" >> $uninst
                echo "rm -rf /opt/lsi/LSIStorageAuthority 2>|/dev/null" >> $uninst
                echo "if [ -d "/opt/lsi" ]; then" >> $uninst
                echo "     rmdir /opt/lsi 2>|/dev/null" >> $uninst
                echo "fi" >> $uninst
                echo "rm -rf /etc/init.d/LsiSASH 2>|/dev/null" >> $uninst

		echo "echo" >> $uninst
                echo "echo \"LSA uninstallation successful!\"" >> $uninst
                echo "echo" >> $uninst

		chmod +x $uninst
	fi
#fi

}

update_conf ()
{
        	# replace with old sensitive data
	SMTP_FILE="/opt/lsa_temp/smtpServer"
	KEY_FILE="/opt/lsa_temp/key.store"
	VALUE_FILE="/opt/lsa_temp/value.store"

	LSA_CONF="/opt/lsa_temp/LSA.conf"
	MONITOR_CONF="/opt/lsa_temp/config-current.json"
	MANAGED_SERVERS_DIR="/opt/lsa_temp/managedservers"
	
	LSA_home="/opt/lsi/LSIStorageAuthority"

	#

	if [ -f "$SMTP_FILE" ];
	then
		rm -f "$LSA_home/bin/smtpServer"
		cp "$SMTP_FILE" "$LSA_home/bin"
	fi

	#

	if [ -f "$KEY_FILE" ];
	then
		rm -f "$LSA_home/bin/key.store"
		cp "$KEY_FILE" "$LSA_home/bin"
	fi

	#

	if [ -f "$VALUE_FILE" ];
	then
		rm -f "$LSA_home/bin/value.store"
		cp "$VALUE_FILE" "$LSA_home/bin"
	fi

	#

	#if [ -f "$LSA_CONF" ];
	#then
	#	rm -f "$LSA_home/conf/LSA.conf"
	#	cp "$LSA_CONF" "$LSA_home/conf"
	#fi


	#

	if [ -f "$MONITOR_CONF" ];
	then
		rm -f "$LSA_home/conf/monitor/config-current.json"
		cp "$MONITOR_CONF" "$LSA_home/conf/monitor"
	fi

	#

	rm -rf "/opt/lsa_temp"

	new_LSA_port=$LSAappPort
	install_type="installation_type = "
	#echo $old_nginx_port
	#echo $old_LSA_port
	#echo $new_LSA_port

	var=`cat /opt/lsi/LSIStorageAuthority/installtype`
	act_str="retrieve_range_of_events_since = 0"
	rep_str="retrieve_range_of_events_since = $setup_state"

	if [ "$var" == "localagent" ]; then
	new_installation_type="129"
	old_installation_type=`grep "installation_type = " $LSA_home/conf/LSA.conf |  cut -b 21-23`
	sed -e s/"$install_type$old_installation_type"/"$install_type$new_installation_type"/g "$LSA_home/conf/LSA.conf" > "$LSA_home/conf/LSA.conf_new"
	cp "$LSA_home/conf/LSA.conf_new" "$LSA_home/conf/LSA.conf"
	rm -rf "$LSA_home/conf/LSA.conf_new"	
	fi

	sed -e s/"$act_str"/"$rep_str"/g "$LSA_home/conf/LSA.conf" > "$LSA_home/conf/LSA.conf_new"
	mv "$LSA_home/conf/LSA.conf_new" "$LSA_home/conf/LSA.conf"

        var0="[Desktop Entry]"
        var1="Name=LaunchLSA"
        var2="Comment=Launch LSA from shortcut"
        var3="Exec=/opt/lsi/LSIStorageAuthority/startupLSAUI.sh"
        var4="Terminal=false"
        var5="Type=Application"

	#FILE="/$USER/Desktop"
 
	#if [ -d "$FILE" ];
	#then
	        #echo -e "$var0\n$var1\n$var2\n$var3\n$var4\n$var5\n" >> /$USER/Desktop/LaunchLSA.desktop
	        #ln -sf /opt/lsi/LSIStorageAuthority/startupLSAUI.sh /$USER/Desktop/LaunchLSA
	        #chmod +x /$USER/Desktop/LaunchLSA.desktop
		#echo "Desktop shortcut created"
	#else
		#echo "Desktop shortcut not created"
	#fi
}

service_restart ()
{
        ln -sf /opt/lsi/LSA/libs/libcrypto.so.3 /opt/lsi/LSIStorageAuthority/bin/libcrypto.so.3
        ln -sf /opt/lsi/LSA/libs/libssl.so.3 /opt/lsi/LSIStorageAuthority/bin/libssl.so.3

	if [ -d /opt/lsi/LSA/libs2 ]; then
		ln -sf /opt/lsi/LSA/libs2/libslp.so.1.0.0 /opt/lsi/LSIStorageAuthority/plugins/libslp.so.1
                if [ -e /etc/os-release ]; then
                   redHatOS=`cat /etc/os-release | grep  -w "NAME=" |  cut -b 7-13`
                  if [ "$redHatOS" = "Red Hat" ]; then
                    version=`cat /etc/os-release | grep  -w "VERSION=" |  cut -b 10-10`
                    if [ "$version" -gt 7 ]; then
                       ln -sf /usr/lib64/libnsl.so.2 /opt/lsi/LSIStorageAuthority/bin/libnsl.so.1
                    fi
                  fi
                fi
	fi

	test_crypt_lib=`ldconfig -p | grep libcrypt.so.1`
        CRYPT_LIB="libcrypt.so.2"
        test_crypt_lib_count=`echo $test_crypt_lib | wc -m`
        if [ $test_crypt_lib_count -gt 1 ] ; then
                target=`echo $test_crypt_lib | awk '{print $4}' | head -1`
                ln -s $target /opt/lsi/LSIStorageAuthority/bin/$CRYPT_LIB 2>|/dev/null
        fi

        LDAP_LIB="libldap-2.4.so.2"
        LDAPR_LIB="libldap_r-2.4.so.2"

        test_ldap_lib=`ldconfig -p | grep $LDAP_LIB`
        test_ldap_lib_count=`echo $test_ldap_lib | wc -m`

        if [ $test_ldap_lib_count -eq 1 ] ; then
            test_ldapr_lib=`ldconfig -p | grep $LDAPR_LIB`
            test_ldapr_lib_count=`echo $test_ldapr_lib | wc -m`

            if [ $test_ldapr_lib_count -gt 1 ] ; then

                target=`echo $test_ldapr_lib | awk '{print $4}' | head -1`
                #echo "Creating symbolic link to LDAP re-entrant library ($target) for LSA to work..."

                ln -s $target /opt/lsi/LSIStorageAuthority/bin/$LDAP_LIB 2>|/dev/null
            fi
        fi
	
	/etc/init.d/LsiSASH start

	echo
        echo "LSA installation successful!"
        echo
}

#######################################
############ Main #####################
#######################################
	getUserInput
	install_rpms
	update_conf
	service_restart
